package jp.ossc.installer.gui.command;

import java.io.IOException;

import jp.ossc.installer.gui.Setup;
import jp.ossc.installer.gui.log.LogInputStream;
import jp.ossc.installer.gui.thread.ProcessThread;

/**
 * v_Ng̎s(CXg[Ȃ)s\ǂsNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class CheckExecuteCmd {

    /**
     * [h(CXg[AACXg[AAbvf[g)<br>
     */
    private int mode;

    /**
     * RXgN^[<br>
     * @param mode [h
     */
    public CheckExecuteCmd (int mode) {
        this.mode = mode;
    }

    /**
     * AntɎ߂<br>
     * @param no OSSԍ
     * @param installedNo ɃCXg[OSSԍ(J}؂)
     * @return IR[h
     */
    public int execute(final int no, final String installedNo) {
        final boolean dubug = Boolean.valueOf(System.getProperty("debug"));
        ProcessThread procThread = null;
        LogInputStream logInputStream = null;
        LogInputStream errorInputStream = null;
        int exitValue = -1;
        try {
            procThread = Setup.checkExecute(no, mode, installedNo);
            if (procThread == null) {
                // Ȃ
            } else {
                logInputStream = procThread.getLogInputStream();
                String line = null;
                while ((line = logInputStream.readLine()) != null) {
                    if (dubug) {
                        System.out.println(line);
                    } else {
                        // Ȃ
                    }
                }
                exitValue = procThread.getExitValue();
                if (exitValue != 0) {
                    errorInputStream = procThread.getErrorInputStream();
                    while ((line = errorInputStream.readLine()) != null) {
                        System.err.println(line);
                    }
                } else {
                    // Ȃ
                }
            }

            // Ԃl̐ݒ
            return exitValue;
        } catch (IOException ie) {
            throw new RuntimeException(ie);
        } catch (InterruptedException ine) {
            throw new RuntimeException(ine);
        } finally {
            try {
                logInputStream.close();
            } catch (Exception e) {
                // Ȃ
            }
            try {
                errorInputStream.close();
            } catch (Exception e) {
                // Ȃ
            }
        }
    }

}
