package jp.ossc.installer.tools.inventory;

import java.io.File;
import java.io.IOException;
import java.util.Map;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.ossc.installer.util.OpenStandiaXmlFile;

import org.xml.sax.SAXException;

/**
 * Cxg[fBNg[ɂăACXg[̏SNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class UnInstall extends AbstaractInventory {

    /**
     * Cxg[t@CCXg[L^폜<br>
     * @param no v_NgNo
     * @param stackXml X^bN`t@C
     * @throws IOException IOException
     * @throws SAXException SAXException
     * @throws ParserConfigurationException ParserConfigurationException
     * @throws TransformerException TransformerException
     * @see jp.ossc.installer.tools.inventory.AbstaractInventory#execute(java.lang.String, java.io.File)
     */
    @Override
    public void execute(final String no, final File stackXml)
        throws IOException, ParserConfigurationException, SAXException,
        TransformerException {

        // ʃNXs
        super.execute(no, stackXml);

        // v_Ng폜
        final File productXml = OpenStandiaXmlFile.getProductFilePath(
            stackXml, no);
        final Map<String, String> productXmlMap = OpenStandiaXmlFile
                .getProductXmlProperties(stackXml, productXml);
        final String productName = productXmlMap.get(PRODUCT_NAME);
        deleteProductNode(productName);

        // v_Ng擾
        final int installedProductNum = getProductNodeNum();

        // Ẵv_NgACXg[ς݂̏ꍇ́ACxg[t@C폜
        if (installedProductNum > 0) {
            // Ȃ
        } else {
            deleteInventoryFile();
        }

    }

}
