package jp.ossc.installer.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * O[eBeB[NXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class LogUtil {

    /**
     * Ot@CɕtvtBbNX̓ttH[}bg<br>
     */
    private static final String LOG_PREFIX_FORMAT = "yyyyMMddHHmmssS";

    /**
     * Ot@C̃tH[}bg<br>
     */
    private static final String LOG_FILE_FORMAT = "log-%s.txt";

    /**
     * RXgN^[<br>
     */
    private LogUtil () {
        super();
    }

    /**
     * w肳ꂽfBNgɁAw肳ꂽO()o͂܂B<br>
     * @param dir o̓fBNg
     * @param log O()
     * @throws IOException IOException
     */
    public static void outputLog(final String dir, final String log)
        throws IOException {
        if (dir == null || dir.equals("")) {
            // Ȃ
        } else if (log == null || log.equals("")) {
            // Ȃ
        } else {
            final Date now = new Date();
            final SimpleDateFormat format = new SimpleDateFormat(
                LOG_PREFIX_FORMAT);
            final String postfix = format.format(now);
            final String logFileName = String
                    .format(LOG_FILE_FORMAT, postfix);
            final File logFile = new File(dir + "/" + logFileName)
                    .getAbsoluteFile();
            final File logDir = logFile.getParentFile();
            logDir.mkdirs();
            if (logFile.exists()) {
                // Ȃ
            } else {
                logFile.createNewFile();
            }
            FileWriter fw = null;
            BufferedWriter bw = null;
            PrintWriter pw = null;
            try {
                fw = new FileWriter(logFile);
                bw = new BufferedWriter(fw);
                pw = new PrintWriter(bw);
                pw.print(log);
            } finally {
                try {
                    pw.close();
                } catch (Exception e) {
                    // Ȃ
                }
                try {
                    bw.close();
                } catch (Exception e) {
                    // Ȃ
                }
                try {
                    fw.close();
                } catch (Exception e) {
                    // Ȃ
                }
            }
        }
    }

}
