package jp.ossc.installer.tools.inventory;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.xml.sax.SAXException;

/**
 * Cxg[fBNg[ɂăAvP[VCXg[Ă邩mFSNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class CheckApplication extends AbstractCheckInventory {

    /**
     * Cxg[t@CAvP[VR\[ɏo͂܂B<br>
     *  ɃAvP[VCXg[ĂȂꍇ́ARuntimeException𔭐܂B<br>
     * @param applicationName AvP[V
     * @param stackXml X^bN`t@C
     * @throws IOException IOException
     * @throws SAXException SAXException
     * @throws ParserConfigurationException ParserConfigurationException
     * @throws TransformerException TransformerException
     * @see jp.ossc.installer.tools.inventory.AbstaractCheckInventory#execute(java.lang.String, java.io.File)
     */
    @Override
    public void execute(final String applicationName, final File stackXml)
        throws IOException, ParserConfigurationException, SAXException,
        TransformerException {

        // ʃNXs
        try {
            super.execute(applicationName, stackXml);
        } catch (RuntimeException e) {
            if (e.getMessage().equals(ERR_MSG_NOT_INSTALLED_OPENSTANDIA)) {
                // Cxg[t@C݂Ȃꍇ
                System.out.println("OpenStandia" + " " + NOT_INSTALLED_VALUE);
            } else {
                // Ȃ
            }
            throw e;
        }

        // OpenStandia/Installeȑ擾
        final String installedApplicationVer = getApplicationVerNode(applicationName);

        // Wo
        System.out.println(applicationName + " " + installedApplicationVer);

        // AvP[VCXg[Ă邩ǂ
        if (installedApplicationVer.equals(NOT_INSTALLED_VALUE)) {
            throw new RuntimeException(applicationName + "̓CXg[Ă܂B");
        } else {
            // Ȃ
        }

    }

}
