package jp.ossc.installer.tools.inventory;

import java.io.File;

/**
 * Cxg[fBNg[QƂɊւ郁CNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class ReadMain {

    /**
     * Cxg[fBNg[OpenStandia/Installer̃o[W擾<br>
     */
    private static final int MODE_GET_OPENSTANDIA_VERSION = 0;

    /**
     * Cxg[fBNg[w肳ꂽv_Ng̃o[W擾<br>
     */
    private static final int MODE_GET_PRODUCT_VERSION = 1;

    /**
     * 񃁃bZ[W : m̏[h̏ꍇ<br>
     */
    private static final String INFO_MSG_UNKNOWN_MODE = "m̏[hłB : [%d]";

    /**
     * C<br>
     * @param args 
     *               [0] : 0 : OpenStandião[W擾 / 1 : v_Ng̃o[W擾
     *               [1] : X^bN`t@C(tpX)
     *               [2] : [0]0̏ꍇ : AvP[V
     *                   : [0]1̏ꍇ : v_Ng
     * @throws Throwable Throwable
     */
    public static void main(String[] args) throws Throwable {
        try {
            // ̎擾
            final int mode = Integer.parseInt(args[0]);
            final String stackXmlPath = args[1];
            final String name = args[2];

            // [hɂ蕪
            final File stackXml = new File(stackXmlPath);
            if (mode == MODE_GET_OPENSTANDIA_VERSION) {
                CheckApplication checkApplication = new CheckApplication();
                checkApplication.execute(name, stackXml);
            } else if (mode == MODE_GET_PRODUCT_VERSION) {
                AbstaractInventory checkProduct = new CheckProduct();
                checkProduct.execute(name, stackXml);
            } else {
                final String msg = String.format(INFO_MSG_UNKNOWN_MODE, mode);
                throw new IllegalArgumentException(msg);
            }
        } catch (Throwable t) {
            throw t;
        }
    }

}
